#include "testlib.h"
#include <iostream>

int main(int argc, char* argv[])
{
  registerGen(argc, argv, 1);
  ensuref(argc == 4, "generator need 3 params");
  int32_t n = atoi(argv[1]);
  int32_t range_length = atoi(argv[2]);
  int32_t diff = atoi(argv[3]);
  ensuref(0 <= diff && diff <= 9, "diff must be in range [0..9]");

  std::cout << n << std::endl;
  std::string sherlock_number, moriarty_number;

  int32_t cp = 0, cr = 0, digit = 0;
  while (cp < n) {
    cr = 0;
    while (cr < range_length && cp < n) {
      sherlock_number.push_back('0' + digit);
      moriarty_number.push_back('0' + (diff + digit) % 10);
      ++cp; ++cr;
    }
    digit = (digit + 1) % 10;
  }

  std::cout << sherlock_number << std::endl;
  std::cout << moriarty_number << std::endl;
  return 0;
}
