#include <iostream>
#include <algorithm>
#include <string>
#include <cstdint>

int32_t CalculateMoriartyHits(const std::string &sherlock_num,
                              const std::string &moriarty_num) {
  int32_t hits = 0;
  for (int32_t i = 0; i < sherlock_num.size(); ++i) {
    if(sherlock_num[i] < moriarty_num[i]) {
      ++hits;
    }
  }
  return hits;
}

int32_t CalculateSherlockHits(const std::string &sherlock_num,
                              const std::string &moriarty_num) {
  int32_t hits = 0;
  for (uint32_t i = 0; i < sherlock_num.size(); ++i) {
    if(sherlock_num[i] > moriarty_num[i]) {
      ++hits;
    }
  }
  return hits;
}

int main() {
  int32_t n;
  std::string sherlock_num, moriarty_num;
  std::cin >> n;
  std::cin >> sherlock_num;
  std::cin >> moriarty_num;
  std::sort(moriarty_num.begin(), moriarty_num.end());
  int32_t max_ans = -1, min_ans = INT32_MAX;
  std::string min_seq, max_seq;
  do {
    int32_t sherlock_hits = CalculateSherlockHits(sherlock_num,
                                                  moriarty_num);
    int32_t moriarty_hits = CalculateMoriartyHits(sherlock_num,
                                                  moriarty_num);
    if (sherlock_hits < min_ans) {
      min_ans = sherlock_hits;
      min_seq = moriarty_num;
    }
    if (moriarty_hits > max_ans) {
      max_ans = moriarty_hits;
      max_seq = moriarty_num;
    }
  } while (std::next_permutation(moriarty_num.begin(), moriarty_num.end()));

  std::cout << min_ans << std::endl;
  //std::cout << min_seq << std::endl;
  std::cout << max_ans << std::endl;
  //std::cout << max_seq << std::endl;
  return 0;
}
