#include "testlib.h"
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <iomanip>
#include <ctime>
#include <cmath>
#include <bitset>

//#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

vector<string> arr;
vector<char> symb;

string gen_next_str(string st, int alph)
{
    char last = symb[alph - 1];
    vector<int> can_at;

    for (int i = 0; i < st.size(); ++i)
    {
        if (st[i] != last)
        {
            can_at.push_back(i);
        }
    }

    if (can_at.empty())
    {
        return st;
    }
    else
    {
        string ans = st.substr(0, can_at[rnd.next(0, (int)can_at.size() - 1)] + 1);
        int ptr = 0;
        for (int i = 0; i < alph; ++i)
        {
            if (ans[(int)ans.size() - 1] == symb[i])
            {
                ptr = i;
                break;
            }
        }
        ans[(int)ans.size() - 1] = symb[rnd.next(ptr + 1, alph - 1)];
        return ans;
    }
}

string gen_next_str_len(string st, int alph, int min_len, int max_len)
{
    min_len = min(min_len, max_len);
    string ans = gen_next_str(st.substr(0, max_len), alph);
    min_len = max((int)ans.size(), min_len);

    int cur_len = rnd.next(min_len, max_len);
    for (int i = ans.size(); i < max_len; ++i)
    {
        ans += symb[rnd.next(0, alph - 1)];
    }
    return ans;
}

int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);

	//int n = atoi(argv[1]);
	int len = atoi(argv[1]);
	int min_start_len = atoi(argv[2]);
	int max_start_len = atoi(argv[3]);
	int on_break = atoi(argv[4]);
	int min_dec = atoi(argv[5]);
	int max_dec = atoi(argv[6]);
	int alph = atoi(argv[7]);

    assert(max_start_len <= len);
    assert(alph <= 26);

    symb.resize(26);
    for (int i = 0; i < 26; ++i)
    {
        symb[i] = 'a' + i;
    }
    shuffle(symb.begin(), symb.end());
    sort(symb.begin(), symb.begin() + alph);

    string main_w = "";
    int cur_len = rnd.next(min_start_len, max_start_len);
    for (int i = 0; i < cur_len; ++i)
    {
        main_w += symb[rnd.next(0, alph - 1)];
    }

    int n = 1;
    arr.push_back(main_w);
    len -= (int)main_w.size();
    bool good = true;
    while (len > 0)
    {
        while (arr[n - 1].size() > on_break && len > 0 && good)
        {
            int last_len = arr[n - 1].size();
            int new_len = min(len, max(1, last_len - rnd.next(min_dec, max_dec)));
            arr.push_back(arr[n - 1].substr(0, new_len));
            while (new_len <= on_break && new_len < len)
            {
                good = false;
                arr[n] += arr[n - 1][arr[n].size()];
                ++new_len;
            }
            ++n;
            len -= new_len;
        }
        good = true;
        if (len > 0)
        {
            string next_of = gen_next_str_len(arr[n - 1], alph, min_start_len, min(max_start_len, len));

            int j = 0;
            while (j < arr[n - 1].size() && j < next_of.size() && arr[n - 1][j] == next_of[j]) ++j;
            on_break = j + 1;
            arr.push_back(next_of);
            ++n;
            len -= next_of.size();
        }
    }

    printf("%d\n", n);

    for (int i = 0; i < n; ++i)
    {
        printf("#%s\n", arr[i].c_str());
    }

	return 0;
}
