#include "testlib.h"
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <iomanip>
#include <ctime>
#include <cmath>
#include <bitset>

//#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;


vector<string> arr;
vector<char> symb;
vector<int> cut_on;

int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int len = atoi(argv[2]);
	int min_len = atoi(argv[3]);
	int cut_len = atoi(argv[4]);
	int change = atoi(argv[5]);
	int alph = atoi(argv[6]);

    assert(n * min_len + cut_len <= len);
    assert(alph <= 26);

    symb.resize(26);
    for (int i = 0; i < 26; ++i)
    {
        symb[i] = 'a' + i;
    }
    shuffle(symb.begin(), symb.end());
    sort(symb.begin(), symb.begin() + alph);

    arr.resize(n);
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < min_len; ++j)
        {
            arr[i] += symb[rnd.next(0, alph - 1)];
        }
    }

    for (int i = 0; i < len - n * min_len - cut_len; ++i)
    {
        int now = rnd.next(0, n - 1);
        arr[now] += symb[rnd.next(0, alph - 1)];
    }
    sort(arr.begin(), arr.end());

    for (int i = 0; i < change; ++i)
    {
        int now = rnd.next(0, n - 1);
        int at = rnd.next(0, (int)arr[now].size() - 1);
        arr[now][at] = symb[rnd.next(0, alph - 1)];
    }

    cut_on.resize(n);
    for (int i = 0; i < n; ++i)
    {
        cut_on[i] = i;
    }
    shuffle(cut_on.begin(), cut_on.end());
    sort(cut_on.begin(), cut_on.begin() + cut_len);

    printf("%d\n", n + cut_len);

    int ptr = 0;
    for (int i = 0; i < n; ++i)
    {
        if (ptr < cut_len && i == cut_on[ptr])
        {
            printf("#%c\n", symb[rnd.next(max(0, alph - 5), alph - 1)]);
            ++ptr;
        }
        printf("#%s\n", arr[i].c_str());
    }

	return 0;
}
