#include "testlib.h"
#include <string>

using namespace std;

typedef long long int ll;
typedef long double ld;

const int MAX_N = 500 * 1000;
const int MAX_LEN_GROUP1 = 15;
const int MAX_LEN_GROUP2 = 1000;
const int MAX_LEN_GROUP3 = 100 * 1000;
const int MAX_LEN_GROUP4 = 500 * 1000;

int main(int argc, char* argv[])
{
    registerValidation(argc, argv);

    int n = inf.readInt(1, MAX_N, "n");
    inf.readEoln();

    string now;
    int sum_len = 0;
    for (int i = 0; i < n; ++i)
    {
        now = inf.readToken("#[a-z]{1, " + vtos(MAX_LEN_GROUP4) + "}", "s_" + vtos(i + 1));
        sum_len += (int)now.size() - 1;
        inf.readEoln();
    }

    // 1 <= n <= sum_len, 1 <= sum_len
    if (validator.group() == "samples" || validator.group() == "group1")
    {
        ensuref(sum_len <= MAX_LEN_GROUP1, "sum of string lengths more then %d", MAX_LEN_GROUP1);
    }
    else if (validator.group() == "group2")
    {
        ensuref(sum_len <= MAX_LEN_GROUP2, "sum of string lengths more then %d", MAX_LEN_GROUP2);
    }
    else if (validator.group() == "group3")
    {
        ensuref(sum_len <= MAX_LEN_GROUP3, "sum of string lengths more then %d", MAX_LEN_GROUP3);
    }
    else if (validator.group() == "group4")
    {
        ensuref(sum_len <= MAX_LEN_GROUP4, "sum of string lengths more then %d", MAX_LEN_GROUP4);
    }
    else
    {
        ensuref(false, "no group for this test");
    }

    inf.readEof();

    return 0;
}
